package com.ducat.springboot.aop;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.context.annotation.EnableAspectJAutoProxy;

import com.ducat.springboot.aop.model.Myemployee;

@SpringBootApplication

// @EnableAspectJAutoProxy annotation enables support for handling the components marked with @Aspect annotation. It is similar to <aop:aspectj-autoproxy> tag in the xml configuration.
@EnableAspectJAutoProxy
public class Myapplication {

	public static void main(String[] args) {

		ConfigurableApplicationContext context = SpringApplication.run(Myapplication.class, args);

		// Fetching the employee object from the application context.
		Myemployee myemployee = context.getBean(Myemployee.class);

		// Displaying employee details.
		myemployee.display();

		// Closing the context object.
		context.close();
	}
}