package com.ducat.springboot.aop.aspects;

import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.After;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;
import org.springframework.stereotype.Component;

// @Aspect annotation enables the spring aop functionality in an application. Tells the developer that this class has advice methods.
@Aspect
@Component
public class Myemployeeaspect {

	// Pointcut definition to display all the available methods i.e. the advice will be called for all the methods.
	@Pointcut(value= "execution(* com.ducat.springboot.aop.model.Myemployee.*(..))")
	private void displayEmployee() { }

	// Method is executed after the method matching with a pointcut expression.
	@After(value= "displayEmployee()")
	public void afterAdvice(JoinPoint jp){
		System.out.println("Inside afterAdvice() method...." + " Inserted after= " + jp.getSignature().getName() + " method");
	}  
}